From c7c827daec9eb5044e8ab8b264921baaf96ca91d Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 609/1001] Front and back ends for SavedNotifications


---

diff --git a/hubs/app.py b/hubs/app.py
index 4432e91..957a809 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -19,6 +19,7 @@ from flask.ext.oidc import OpenIDConnect
 import fmn.lib
 import hubs.models
 import hubs.widgets
+from hubs.widgets import clean_input
 
 import datanommer.models
 
@@ -530,23 +531,29 @@ def stream(name):
         {'url': '', 'name': 'mentionsFeed', 'matches': []},
     ]
     saved = hubs.models.SavedNotification.by_username(session, name)
+    saved = [n.__json__() for n in saved]
 
-    return flask.render_template('stream.html', feeds=json.dumps(feeds), saved=saved)
+    return flask.render_template('stream.html', feeds=json.dumps(feeds), saved=json.dumps(saved))
 
 
-@app.route('/<user>/notifications')
-@app.route('/<user>/notifications/')
+@app.route('/<user>/notifications', methods=['GET', 'POST'])
+@app.route('/<user>/notifications/', methods=['GET', 'POST'])
 @login_required
 def notifications(user):
     if flask.request.method == 'GET':
         notifications = hubs.models.SavedNotification.by_username(session, user)
         notifications = [n.__json__() for n in notifications]
-        return json.dumps(notifications)
+        return flask.jsonify(notifications)
 
     if flask.request.method == 'POST':
-        markup = bleach.clean(flask.request.data['markup'])
-        link = bleach.clean(flask.request.data['link'])
-        icon = flask.request.data['icon']
+        data = flask.request.json
+        try:
+            # TODO clean these with pingou's new method
+            markup = data['markup']
+            link = data['link']
+            icon = data['secondary_icon']
+        except:
+            return str(flask.request.data)
         notification = hubs.models.SavedNotification(
             username=user,
             markup=markup,
@@ -555,7 +562,9 @@ def notifications(user):
         )
         session.add(notification)
         session.commit()
-        return notification.__json__()
+        return flask.jsonify(
+            dict(notification=notification.__json__(),success=True)
+        )
 
 @app.before_request
 def check_auth():
diff --git a/hubs/models.py b/hubs/models.py
index c8021e4..03217c1 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -490,7 +490,7 @@ class SavedNotification(BASE):
     idx = sa.Column(sa.Integer, primary_key=True)
     markup = sa.Column(sa.Text)
     link = sa.Column(sa.Text)
-    secondary_icon = sa.column(sa.Text)
+    secondary_icon = sa.Column(sa.Text)
     created = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
 
 
@@ -502,16 +502,18 @@ class SavedNotification(BASE):
 
     def __json__(self):
         return {
+            'created': str(self.created),
+            'date_time': str(self.created),
             'idx': self.idx,
-            'markup': bleach.linkify(self.markup),
             'link': bleach.linkify(self.link),
-            'secondary_icon': self.secondary_icon,
-            'created': self.created
+            'markup': bleach.linkify(self.markup),
+            'saved': True,
+            'secondary_icon': self.secondary_icon
         }
 
     @classmethod
     def by_username(cls, session, username):
-        return session.query(cls).filter_by(user=username)
+        return session.query(cls).filter_by(user=username).all()
 
     @classmethod
     def all(cls, session):
diff --git a/hubs/static/client/app/components/Feed.jsx b/hubs/static/client/app/components/Feed.jsx
index 7d9c618..4086e00 100644
--- a/hubs/static/client/app/components/Feed.jsx
+++ b/hubs/static/client/app/components/Feed.jsx
@@ -11,6 +11,10 @@ export default class Feed extends React.Component {
       messageLimit: this.props.messageLimit,
       sse: true,
     };
+    // If it wasn't instantiated with a url or an error happened, bail
+    if (!this.props.url || !this.state.sse) {
+      return;
+    }
     this.source = (!!window.EventSource) ? new EventSource(this.props.url) : {};
     this.source.addEventListener('error', () => {
       this.state.sse = false;
diff --git a/hubs/static/client/app/components/Panel.jsx b/hubs/static/client/app/components/Panel.jsx
index 61e8242..a5aa178 100644
--- a/hubs/static/client/app/components/Panel.jsx
+++ b/hubs/static/client/app/components/Panel.jsx
@@ -1,14 +1,39 @@
 import React from 'react';
+import $ from 'jquery';
 
 import Icon from './Icon.jsx';
 import Markup from './Markup.jsx';
 
 const Panel = function (props) {
+  const payload = {
+    link: props.match.link,
+    markup: props.match.markup,
+    secondary_icon: props.match.secondary_icon,
+  };
+
+  function onClick(data) {
+    $.ajax({
+      type: 'POST',
+      url: '/atelic/notifications/',
+      data: JSON.stringify(data),
+      contentType: 'application/json',
+    }).done(resp => {
+      const id = '#save' + resp.notification.idx;
+      const $saveBtn = $(id);
+      $saveBtn.removeClass('btn-default')
+              .addClass('disabled btn-success')
+              .text('Saved');
+      console.log(resp);
+    });
+  }
+  const button = (<button id={'save' + props.match.idx} onClick={onClick.bind(this, payload)} className="btn btn-default">SAVE</button>);
+
   return (
     <div className="panel panel-default panel-visible">
       <div className="panel-body">
         <Icon match={props.match} />
         <Markup match={props.match} />
+        {button}
       </div>
     </div>
   );
diff --git a/hubs/static/client/app/index.jsx b/hubs/static/client/app/index.jsx
index 7641684..3976b89 100644
--- a/hubs/static/client/app/index.jsx
+++ b/hubs/static/client/app/index.jsx
@@ -2,4 +2,8 @@
  * since the feed component places itself on window.
  * The feed will not work without it.
  */
+import $ from 'jquery';
+
 import Feed from './components/Feed.jsx'; // eslint-disable-line
+
+window.$ = $;
